import HtmlWebPackPlugin from "html-webpack-plugin";
import * as webpack from 'webpack';
import merge from 'webpack-merge';
import common from './webpack.common';

const config: webpack.Configuration = merge(
    common,
    {
        mode: "development",
        entry: "./src/ViewSrc/index.ts",
        output: { pathinfo: false },
        devtool: "eval-source-map",
        devServer: {
            // contentBase: "./dist/",
            static: false,
            port: 7776,
            host: "0.0.0.0",
            hot: true,
        },
        plugins: [
            // new webpack.NamedModulesPlugin(),//Hot
            new webpack.HotModuleReplacementPlugin(),//Hot
            new HtmlWebPackPlugin({
                title: "webCAD",
                // template: './src/index.html'
            }),
        ]
    }
);

export default config;
