import * as THREE from 'three';
import { KeyBoard, MouseKey } from './KeyEnum';
import { Viewer } from './Viewer';
export declare enum CameraControlState {
    Null = 0,
    Pan = 1,
    Rotate = 2,
    Scale = 3
}
export declare class CameraControls {
    m_TouthTypeList: CameraControlState[];
    m_domElement: HTMLElement;
    m_StartClickPoint: THREE.Vector3;
    m_EndClickPoint: THREE.Vector3;
    m_DollyStart: THREE.Vector2;
    m_DollyEnd: THREE.Vector2;
    m_KeyDown: Map<KeyBoard, boolean>;
    m_MouseDown: Map<MouseKey, boolean>;
    m_State: CameraControlState;
    m_Viewer: Viewer;
    m_LeftUseRotate: boolean;
    constructor(viewer: Viewer);
    RegisterEvent(): void;
    /**
     * 窗体失去焦点时.
     *
     * @memberof CameraControls
     */
    onBlur: () => void;
    onTouchStart: (event: TouchEvent) => void;
    onTouchEnd: (event: TouchEvent) => void;
    onTouchMove: (event: TouchEvent) => void;
    beginRotate(): void;
    lastMiddleClickTime: number;
    onMouseDown: (event: MouseEvent) => void;
    onMouseUp: (event: MouseEvent) => void;
    onMouseMove: (event: MouseEvent) => void;
    /**
     * 鼠标滚轮事件
     *
     * @memberof CameraControls
     */
    onMouseWheel: (event: WheelEvent) => void;
    onKeyDown: (event: KeyboardEvent) => void;
    onKeyUp: (event: KeyboardEvent) => void;
}
