import { Mesh, Scene, Vector3, WebGLRenderer } from "three";
import { CameraControls } from ".";
import { CameraUpdate } from "./CameraUpdate";
export declare class Viewer {
    m_LookTarget: any;
    m_Camera: CameraUpdate;
    m_CameraCtrl: CameraControls;
    m_bNeedUpdate: boolean;
    m_Render: WebGLRenderer;
    m_DomEl: HTMLElement;
    _Height: number;
    _Width: number;
    m_Scene: Scene;
    /**
     *
     * @param {HTMLElement} canvasContainer 可以传入一个div或者一个画布
     * @memberof Viewer
     */
    constructor(canvasContainer: HTMLElement);
    initRender(canvasContainer: HTMLElement): void;
    OnSize: (width?: any, height?: any) => void;
    StartRender: () => void;
    Render(): void;
    ScreenToWorld(pt: Vector3, planVec?: Vector3): void;
    WorldToScreen(pt: Vector3): void;
    /**
     * 更新视角观测目标(物体中心)
     *
     * @memberof Viewer
     */
    UpdateLockTarget(): void;
    Rotate(mouseMove: Vector3): void;
    Pan(mouseMove: Vector3): void;
    Zoom(scale: number, center?: Vector3): void;
    ZoomAll(): void;
    ViewToTop(): void;
    ViewToFront(): void;
    ViewToSwiso(): void;
    oldMesh: Mesh;
    SelectByPoint(x: number, y: number): void;
    SelectBlock(blockMeshMap: Map<number, number>, dataID: number): void;
}
